# Auteur Rayane ELMEDJADJI

import sys
import os
from pathlib import Path
from statistics import mean
class StructVar:
    def __init__(self):
        self.chromosome = None
        self.position = None
        self.id = None
        self.ref = None
        self.alt = None
        self.sample = None
        self.type = None
        self.info= None
        self.sample_full = None
    # Setters
    def set_chromosome(self, chrom):
        self.chromosome = chrom

    def set_position(self, pos):
        self.position = pos

    def set_id(self, identifier):
        self.id = identifier

    def set_ref(self, reference):
        self.ref = reference

    def set_alt(self, alternate):
        self.alt = alternate

    def set_sample(self, sample):
        self.sample = sample

    def set_type(self, type_):
        self.type = type_

    def set_info(self, i):
        self.info = i
    def set_sample_full(self,s):
        self.sample_full = s

    # Getters
    def get_chromosome(self):
        return self.chromosome

    def get_position(self):
        return self.position

    def get_id(self):
        return self.id

    def get_ref(self):
        return self.ref

    def get_alt(self):
        return self.alt

    def get_sample(self):
        return self.sample

    def get_type(self):
        return self.type

    def get_info(self):
        return self.info
    def get_sample_full(self):
        return self.sample_full

    def equals(self, other):
        if self.type == other.get_type():
            if (self.type == "INS" and self.alt == other.get_alt()) or (self.type == "DEL" and self.ref == other.get_ref()):
                return True
        return False

    def give_len(self):
        infos =self.info.split(';')
        #print(infos)
        for info in infos:
            if "SVLEN" in info:
                att=info.split('=')
                return abs(int(att[1]))
    def get_sequence(self):
        if self.type == "INS":
            return self.alt
        elif self.type == "DEL":
            return self.ref
        else:
            return "unknown type!"

    def give_profondeur(self):
        smp=self.sample_full
        #print(smp)
        stuff=smp.split(':')
        #print(stuff)
        return int(stuff[2])+int(stuff[3])
    def give_af(self):
        inf=self.info
        stuff=inf.split(';')
        for s in stuff:
            if "AF" in s:
                af = s.split('=')[1]
                return float(af)
    def display_noseq(self):
        print(f"Chromosome: {self.chromosome}, Position: {self.position}, ID: {self.id}, Sample: {self.sample}, info: {self.info}, sample: {self.sample_full}")

        
    def display(self):
        print(f"Chromosome: {self.chromosome}, Position: {self.position}, ID: {self.id}, Ref: {self.ref}, Alt: {self.alt}, Sample: {self.sample}, info: {self.info}")


def equals(sv1,sv2):
    if sv1.get_type()!=sv2.get_type():
        return False
    


def split_line(line, delimiter='\t'):
    return line.strip().split(delimiter)

def read_vcf(file_path):
    try:
        with open(file_path, 'r') as file:
            SVs = []
            nb_ins = 0
            nb_del = 0
            
            for line in file:
                if line.startswith('#'):
                    # Ligne d'en-tête détectée
                    continue
                else:
                    # Variant structural
                    sv = StructVar()
                    attributs = split_line(line)
                    
                    sv.set_chromosome(attributs[0])
                    sv.set_position(attributs[1])
                    sv.set_id(attributs[2])
                    sv.set_ref(attributs[3])
                    sv.set_alt(attributs[4])
                    sv.set_info(attributs[7])
                    sv.set_sample_full(attributs[9])
                    infos = sv.get_info().split(";")
                    for info in infos:
                        if "SVTYPE" in info:
                            #print(info)
                            atr=info.split('=')
                            sv.set_type(atr[1])

                    f = split_line(attributs[9], ':')
                    sv.set_sample(f[0])
                    
                   
                    SVs.append(sv)
            
            nb_sv = len(SVs)
            #print(f"{nb_sv} variants ont été détectés dans votre fichier VCF")
            #print(f"{nb_del} sont des délétions")
            #print(f"{nb_ins} sont des insertions")
            #print(f"taille: {nb_sv}")
            
            return SVs
            
    except FileNotFoundError:
        print(f"Erreur: Impossible d'ouvrir le fichier {file_path}")
        return []


def find_sv_in_range(debut,fin,sv_list):
    res=[]
    for sv in sv_list:
        if int(sv.get_position())>=debut and int(sv.get_position())<=fin:
            res.append(sv)
    return res

def stats_orf(dict_sv):
    file_name=input("Entrer le nom du fichier txt pour mettre les informations concernant votre ORF dedans!: ")
    orf_name=input("Donner un nom à votre ORF: ")
    debut=input("Donner la position de début de votre ORF: ")
    fin=input("Donner la position de fin de votre ORF: ")
    with open(file_name, "w") as file:
        header=["Echantillion","ORF","Nombre de variants","Nombre de deletion","Nombre d'insertion","Long moy","long moy del","long moy ins"]
        data=[]
        for key,value in dict_sv.items():
            new_row=[key,orf_name]
            sv_del=[]
            sv_ins=[]
            sv_other=[]
            sv_length=0
            sv_del_length=0
            sv_ins_length=0
            SVs=find_sv_in_range(int(debut),int(fin),value)
            for sv in SVs:
                sv_type=sv.get_type()
                sv_len=sv.give_len()
                if (filtered and sv.give_profondeur()>0 and sv.give_af()<min_af or sv.give_profondeur()<min_prof):
                    continue
                if sv_type=="DEL":
                    print(len(sv_del))
                    sv_del.append(sv)
                    sv_del_length+=sv_len
                elif sv_type=="INS":
                    sv_ins.append(sv)
                    sv_ins_length+=sv_len
                else:
                    sv_other.append(sv)
                sv_length+=sv_len
            total_count=len(sv_del)+len(sv_ins)+len(sv_other)
            print(key)
            if total_count>0:
                moy_long=sv_length/total_count
            else:
                moy_long=0
            if len(sv_ins)>0:
                moy_long_ins=sv_ins_length/len(sv_ins)
            else:
                moy_long_ins=0
            if len(sv_del)>0:
                moy_long_del=sv_del_length/len(sv_del)
            else:
                moy_long_del=0
            new_row.append(total_count)
            new_row.append(len(sv_del))
            new_row.append(len(sv_ins))
            new_row.append(moy_long)
            new_row.append(moy_long_del)
            new_row.append(moy_long_ins)
            data.append(new_row)
        file.write("\t".join(header) + "\n")
        for row in data:
            file.write("\t".join(map(str, row)) + "\n")



def stats(dict_sv,filtered):
    min_af=float(input("mettez un seuil pour l'AF: "))
    min_prof=int(input("mettez un seuil pour la profondeur: "))
    
    file_name=input("Entrer le nom du fichier txt pour mettre les informations générales dedans!: ")
    with open(file_name, "w") as file:
        
        header=["Echantillion","Nombre de variants","Nombre de deletion","Nombre d'insertion","Long moy","long moy del","long moy ins"]
        data=[]
        for key,value in dict_sv.items():

            new_row=[key]
            sv_del=[]
            sv_ins=[]
            sv_other=[]
            sv_length=0
            sv_del_length=0
            sv_ins_length=0
            for sv in value:
                sv_type=sv.get_type()
                sv_len=sv.give_len()
                print(sv.give_af())
                sv.display_noseq()
                print(sv.give_profondeur())
                if (filtered and sv.give_profondeur()>0 and sv.give_af()<min_af or sv.give_profondeur()<min_prof):
                    continue
                if sv_type=="DEL":
                    print(len(sv_del))
                    sv_del.append(sv)
                    sv_del_length+=sv_len
                elif sv_type=="INS":
                    sv_ins.append(sv)
                    sv_ins_length+=sv_len
                else:
                    sv_other.append(sv)
                sv_length+=sv_len
            total_count=len(sv_del)+len(sv_ins)+len(sv_other)
            print(key)
            if total_count>0:
                moy_long=sv_length/total_count
            else:
                moy_long=0
            if len(sv_ins)>0:
                moy_long_ins=sv_ins_length/len(sv_ins)
            else:
                moy_long_ins=0
            if len(sv_del)>0:
                moy_long_del=sv_del_length/len(sv_del)
            else:
                moy_long_del=0
            new_row.append(total_count)
            new_row.append(len(sv_del))
            new_row.append(len(sv_ins))
            new_row.append(moy_long)
            new_row.append(moy_long_del)
            new_row.append(moy_long_ins)
            data.append(new_row)
        file.write("\t".join(header) + "\n")
        for row in data:
            file.write("\t".join(map(str, row)) + "\n")
            



def main():
    if len(sys.argv) < 2:
        print("Usage: vcfread <dossier> [--write-stats] [--write-stats-orf]", file=sys.stderr)
        return 1

    print(sys.argv[1])
    plt=[15,30,65,90]
    folder = sys.argv[1]
    folder_path = Path(folder)
    vcf_files = list(folder_path.glob("*.vcf"))
    dict_final=dict()
    for vcf_file in vcf_files:
        print(vcf_file)
        
        SVs= read_vcf(vcf_file)
        dict_final[vcf_file.name]=SVs
        
        for sv in SVs:
            len_sv=sv.give_len()
            
            #print(sv.get_type())
            #print(sv.get_sequence())
    print(len(dict_final))
    if len(sys.argv)==3:
        if sys.argv[2]=="--write-stats":
            stats(dict_final,1)
        if sys.argv[2]=="--write-stats-orf":
            stats_orf(dict_final,1)
    if len(sys.argv)==4:
        stats(dict_final)
        stats_orf(dict_final)
        
    nb_var_fic=[]
    nb_del_fic=[]
    nb_ins_fic=[]
    print(dict_final)
    for key,value in dict_final.items():
        print(key)
        found_sv=find_sv_in_range(47000,48000,value)
        if len(found_sv)>0:
            for sv in found_sv:
                if int(sv.give_len())>=1000:
                    print("found the sv that has 1871 bp")
        count=0
        countdel=0
        countins=0
        countother=0
        lengths=[]
        lengthofdel=[]
        lengthsofins=[]
        for sv in value:

            if int(sv.give_len())>100000:
                continue
            print(sv.display_noseq())
            print((sv.give_af()))
            print(sv.give_profondeur())
            long=sv.give_len()
            lengths.append(long)
            count+=1
            typ=sv.get_type()
            if typ=="INS":
                countins+=1
                lengthsofins.append(long)
            elif typ=="DEL":
                lengthofdel.append(long)
                countdel+=1
            else:
                countother+=1
            
        print("total sv: ", count)
        print("total deletions: ",countdel)
        print(len(lengthofdel))
        print("total insertions: ",countins)
        print(len(lengthsofins))
        print("total other types: ",countother)
        print("moyenne de lengths: ", mean(lengths))
        nb_var_fic.append(count)
        nb_del_fic.append(countdel)
        nb_ins_fic.append(countins)

     
    print(nb_var_fic)
    print(nb_del_fic)
    print(nb_ins_fic)
    
    print("the end!")

        
if __name__ == "__main__":
    sys.exit(main())